# -*- coding: utf-8 -*-
#
#Copyright (C) 2010, Yader Velasquez
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.

import gtk
import pickle
import gobject
import os
import logging
from gettext import gettext as _

_log = logging.getLogger('Log archivo')

def indice_entero(cadena):
    '''return an int from a string with tuple sintax'''
    cadena = cadena.replace('(','')
    cadena = cadena.replace(',','')
    cadena = cadena.replace(')','')
    return int(cadena)

def crear_modelo(indice, path):
    '''create the liststore model for the main block'''
    path = path + '/data/actividades.pkl'
    modelo = gtk.ListStore(gobject.TYPE_INT, gobject.TYPE_STRING, gobject.TYPE_STRING,\
                          gobject.TYPE_STRING)
    vacio = _('None')
    
     
    if not os.path.exists(path):
        _log.debug('THE FILE ACTIVIDADES DID NOT EXISTS')
        archivo = open(path, 'wb')
        dia = {}
        pickle.dump(dia, archivo)
        modelo.append([0, vacio, '', ''])

    else:
        #_log.debug('THE FILE EXISTS')
        archivo = open(path, 'rb')
        dia = pickle.load(archivo)
        contar = 1
    
        if dia.has_key(indice): 
            if len(dia[indice]):
                for activ in dia[indice]:
                    modelo.append([contar, activ[0], activ[1], activ[2]]) 
                    _log.debug(activ)
                    contar += 1
            else:
                modelo.append([0, vacio,' ',' '])
        else :
            modelo.append([0, vacio,' ',' '])

    archivo.close() 
    return modelo

def comprobar_efemeride(path):
    '''test is the ephemeri file exists'''
    path = path + '/data/efemerides.pkl'
    if not os.path.exists(path):
        return False
    else:
        return True

def abrir_efemeride(path):
    '''open the ephemeris file and return a data dictionary'''
    path = path + '/data/efemerides.pkl'
    _log.debug('THE FILE EPHEMERIS EXISTS')        
    archivo = open(path, 'rb')
    texto = pickle.load(archivo)
    archivo.close()
    return texto

def guardar_efemeride(path, file_name):
    '''import, convert and save a new ephemeris database'''
    path = path + '/data/efemerides.pkl'
    di = {}
    file = open(file_name, 'r')
    lines = file.readlines()
    for i in range(len(lines)):
        current_text = lines[i][10 : len(lines[i]) - 2]
        
        for j in range(30, len(current_text),30):
            current_text = current_text[:j] + '\n' + current_text[j + 1 :]
        current_id = lines[i][0 : 8]
        di[current_id] = current_text        
    _log.debug(di)
    _log.debug(type(path))
    file_new = open(path, 'wb') 
    pickle.dump(di,file_new)
    file_new.close()
    file.close()

def guardar_dato(indice, contenido, categoria, bolean, path):
    '''save the content in a file, add the content to a dictionary->list'''
    path = path + '/data/actividades.pkl'    
    indice = str(indice)
    f = open(path, 'rb+wb')
    dia = pickle.load(f)
    if bolean:
        prioridad = _('Important')
    else:
        prioridad = _('Normal')

    if dia.has_key(indice) is False:
        dia[indice] = []
    dia[indice].append([contenido, categoria, prioridad])
    f.seek(0)
    pickle.dump(dia, f)
    f.flush()
    f.close()

def borrar_dato(indice, indice_lista, path):
    '''delete the selected content'''
    path = path + '/data/actividades.pkl'    
    indice_lista = str(indice_lista)
    indice = str(indice)
    indice_lista = indice_entero(indice_lista)
    f = open(path, 'rb+wb')
    dia = pickle.load(f)
    del dia[indice][indice_lista]
    f.seek(0)
    pickle.dump(dia, f)
    f.flush()
    f.close()
