# -*- coding: utf-8 -*-
#
#Copyright (C) 2010, Yader Velasquez
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.

from time import localtime, strftime, mktime
from datetime import datetime

class FechaUnix(object):
    '''for get, convert and return dates based on the unix date'''

    def __init__(self, lista):
        '''init class'''
        self.fecha = datetime(lista[0], lista[1] + 1, lista[2]) 

    def fecha_unix(self):
        '''return a string of the actual date in unix format'''
        self.fecha_unix = mktime(self.fecha.timetuple()) 
        self.fecha_unix = int(self.fecha_unix)
        return str(self.fecha_unix)

    def fecha_formato(self, fecha_unix):
        '''return a nice date from an unix date'''
        self.fecha_unix = fecha_unix
        self.fecha_unix = int(self.fecha_unix) 
        return strftime("%d de %b de %Y", localtime(self.fecha_unix))
    
class FechaNormal(object):
    '''for get, convert and return dates in our popular format'''
    def __init__(self):
        '''nothing to say'''

    def fecha_actual(self):
        '''return the actual date'''
        self.fecha = datetime.today()
        return self.fecha.strftime("%d de %B de %Y")
    
    def fecha_especial(self):
        '''special format of a date for 
        be use it like a dicctionary key'''
        self.fecha = datetime.today()
        return self.fecha.strftime("%d/%m/%y")
    
